SystemOrganization addCategory: #NewTestRunner!

MorphTreeNodeModel subclass: #TestRunnerNode
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewTestRunner'!

TestRunnerNode subclass: #TestClassNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewTestRunner'!

!TestClassNode methodsFor: 'accessing' stamp: 'StephaneDucasse 2/22/2011 14:09'!
browseItem
	ToolSet browse: self item  selector: nil! !

!TestClassNode methodsFor: 'menu' stamp: 'StephaneDucasse 2/23/2011 18:45'!
childNodeClassFromItem: anItem
	^TestMethodNode! !

!TestClassNode methodsFor: 'menu' stamp: 'StephaneDucasse 2/22/2011 14:36'!
childrenItems
	^ self item selectors select: [:each | each beginsWith: 'test']
! !

!TestClassNode methodsFor: 'update' stamp: 'StephaneDucasse 2/23/2011 22:21'!
keepForRegex: aRegExp

	^ aRegExp match: self class name asString  ! !

!TestClassNode methodsFor: 'update' stamp: 'StephaneDucasse 2/23/2011 18:16'!
keepForToken: token

	^ token match: self class name asString  ! !

!TestClassNode methodsFor: 'menu' stamp: 'StephaneDucasse 2/22/2011 14:09'!
methodsInCategory: aCat
	^ self item  methodsInCategory: aCat! !

TestRunnerNode subclass: #TestMethodNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewTestRunner'!

!TestMethodNode methodsFor: 'menu' stamp: 'StephaneDucasse 2/22/2011 14:11'!
browseItem
	ToolSet browse: self itemClass  selector: self selector ! !

!TestMethodNode methodsFor: 'menu' stamp: 'StephaneDucasse 2/22/2011 14:11'!
compiledMethod
	^ self itemClass
		compiledMethodAt: self selector
		ifAbsent: [self itemClass class
				compiledMethodAt: self selector
				ifAbsent: []]! !

!TestMethodNode methodsFor: 'menu' stamp: 'StephaneDucasse 2/22/2011 14:11'!
itemClass
	^ self parentNode parentNode item.
! !

!TestMethodNode methodsFor: 'menu' stamp: 'StephaneDucasse 2/23/2011 22:21'!
keepForRegex: aRegExp

	^ aRegExp match: self selector asString  ! !

!TestMethodNode methodsFor: 'menu' stamp: 'StephaneDucasse 2/23/2011 18:11'!
keepForToken: token

	^ token match: self selector asString  ! !

!TestMethodNode methodsFor: 'printing' stamp: 'StephaneDucasse 2/23/2011 19:00'!
printOn: aStream

	super printOn: aStream.
	self item ifNotNil: [aStream nextPutAll: ' ('; nextPutAll: self item asString; nextPutAll: ')' ]! !

!TestMethodNode methodsFor: 'menu' stamp: 'StephaneDucasse 2/22/2011 14:11'!
selector
	^ self item! !

TestRunnerNode subclass: #TestPackageNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewTestRunner'!

!TestPackageNode methodsFor: 'accessing' stamp: 'StephaneDucasse 2/22/2011 14:07'!
asString
	^ self item packageName! !

!TestPackageNode methodsFor: 'accessing' stamp: 'StephaneDucasse 2/23/2011 18:45'!
childNodeClassFromItem: anItem
	^ TestClassNode! !

!TestPackageNode methodsFor: 'accessing' stamp: 'StephaneDucasse 2/23/2011 17:34'!
childrenItems

	^ self item classes select: [:each | each inheritsFrom: TestCase]! !

!TestPackageNode methodsFor: 'update' stamp: 'StephaneDucasse 2/23/2011 22:22'!
keepForRegex: aRegExp

	^ aRegExp match: self asString! !

!TestPackageNode methodsFor: 'update' stamp: 'StephaneDucasse 2/23/2011 18:32'!
keepForToken: token

	^ token match: self asString! !

!TestRunnerNode methodsFor: 'accessing' stamp: 'StephaneDucasse 2/23/2011 17:48'!
browseItem
	! !

!TestRunnerNode methodsFor: 'menu' stamp: 'StephaneDucasse 2/23/2011 19:01'!
contents
	"Cache the contents (childrenNodes) at this level"
	
	^ contents ifNil: [contents := super contents asOrderedCollection]! !

!TestRunnerNode methodsFor: 'accessing' stamp: 'StephaneDucasse 2/23/2011 17:48'!
doubleClick
	self browseItem! !

!TestRunnerNode methodsFor: 'accessing' stamp: 'StephaneDucasse 2/23/2011 17:48'!
exploreItem
	self explore! !

!TestRunnerNode methodsFor: 'accessing' stamp: 'StephaneDucasse 2/23/2011 17:48'!
inspectItem
	self inspect! !

!TestRunnerNode methodsFor: 'testing' stamp: 'StephaneDucasse 2/23/2011 18:57'!
isEmpty
	
	^ self contents isEmpty! !

!TestRunnerNode methodsFor: 'accessing' stamp: 'StephaneDucasse 2/23/2011 17:48'!
keyStroke: aCharacter from: aTreeMorph 
	aCharacter = $b
		ifTrue: [self browseItem. ^ true].
	aCharacter = $i
		ifTrue: [self inspectItem. ^ true].
	aCharacter = $I
		ifTrue: [self exploreItem. ^ true].
	^ false
! !

!TestRunnerNode methodsFor: 'accessing' stamp: 'StephaneDucasse 3/14/2011 21:25'!
menu: menu shifted: b 
	menu
		add: 'Browse (b)' translated
		target: self
		selector: #browseItem.
	menu
		add: 'Inspect (i)' translated
		target: self
		selector: #inspectItem.
	menu
		add: 'Explore (I)' translated
		target: self
		selector: #exploreItem.
	menu
		add: 'Inspect model' translated
		target: self
		selector: #inspect.
! !

!TestRunnerNode methodsFor: 'update' stamp: 'StephaneDucasse 2/23/2011 19:01'!
updateAccordingTo: aFilter 
	self contents do: [ :n | n updateAccordingTo: aFilter].
	self contents removeAllSuchThat: [ :n | (aFilter keepNode: n) not  and: [n isEmpty]]
	"so that a node is only removed when it does not match a filter and has not children"! !

MorphTreeModel subclass: #TRPackageDisplayer
	instanceVariableNames: 'testRunnerModel rootNodesCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewTestRunner'!

!TRPackageDisplayer commentStamp: 'StephaneDucasse 3/14/2011 22:22' prior: 0!
I'm holding a list of packages with subnodes holding classes.
Probably that we should reuse that behavior from somwhere else.!

!TRPackageDisplayer class methodsFor: 'instance creation' stamp: 'sd 3/18/2011 12:46'!
on: aModel

	^ self new testRunnerModel: aModel; yourself   ! !

!TRPackageDisplayer methodsFor: 't - accessing' stamp: 'StephaneDucasse 3/15/2011 21:54'!
doubleClick
	self selectedNode ifNotNil: [:n | n doubleClick]! !

!TRPackageDisplayer methodsFor: 't - accessing' stamp: 'StephaneDucasse 3/15/2011 21:54'!
keyStroke: anEvent from: aTreeMorph 
	self selectedNode
		ifNotNil: [:current | current keyStroke: anEvent from: aTreeMorph]! !

!TRPackageDisplayer methodsFor: 't - accessing' stamp: 'StephaneDucasse 3/15/2011 21:55'!
menu: menu shifted: b 
	"Set up the menu to apply to the receiver's, 
	honoring the #shifted boolean"
	self selectedNode ifNotNil: [:current | current menu: menu shifted: b].
	^ menu! !

!TRPackageDisplayer methodsFor: 't - accessing' stamp: 'sd 3/18/2011 13:03'!
rootItems
	^ testRunnerModel testPackages! !

!TRPackageDisplayer methodsFor: 't - accessing' stamp: 'StephaneDucasse 3/14/2011 22:14'!
rootNodeClassFromItem: anItem
	^ TestPackageNode! !

!TRPackageDisplayer methodsFor: 't - accessing' stamp: 'StephaneDucasse 3/15/2011 13:53'!
rootNodes
	"Since the model is always computing the nodes, we can cache it locally. 
	Set rootNodesCache to nil to invalidate cache."
	
	^ rootNodesCache 
		ifNil: [ rootNodesCache := super rootNodes asOrderedCollection]! !

!TRPackageDisplayer methodsFor: 't - accessing' stamp: 'sd 3/18/2011 13:09'!
selection: aSelection

	| collection |
	super selection: aSelection.

	collection := aSelection selectedNodePathList collect: [:each |  each last ].
	collection := collection collect: [:each | each item].
	testRunnerModel selectedClasses: collection! !

!TRPackageDisplayer methodsFor: 't - accessing' stamp: 'sd 3/18/2011 12:43'!
testRunnerModel: aModel

	testRunnerModel := aModel! !

Object subclass: #NewTestRunner
	instanceVariableNames: 'packageDisplayer searchedText errorList failedList selectedClasses classes result toolBar classList'
	classVariableNames: 'InitialExtent'
	poolDictionaries: ''
	category: 'NewTestRunner'!

NewTestRunner class
	instanceVariableNames: 'searchedTextList regexpSearch'!

!NewTestRunner commentStamp: 'StephaneDucasse 3/14/2011 18:12' prior: 0!
NewTestRunner

	NewTestRunner open
	
<lint: #ignore rule: #classNotReferenced rational: 'this view is only accessed from menus'>

!

NewTestRunner class
	instanceVariableNames: 'searchedTextList regexpSearch'!

!NewTestRunner class methodsFor: 'settings' stamp: 'StephaneDucasse 2/22/2011 11:45'!
initialExtent
	"Initial extent of the TestRunner window"
	^ InitialExtent ifNil: [InitialExtent := 835@600]
		! !

!NewTestRunner class methodsFor: 'settings' stamp: 'StephaneDucasse 2/22/2011 11:45'!
initialExtent: aPoint
	"Set the initial extent of the TestRunner window"
	InitialExtent := aPoint
		! !

!NewTestRunner class methodsFor: 'world menu' stamp: 'StephaneDucasse 2/22/2011 14:40'!
menuCommandOn: aBuilder
	<worldMenu>
	(aBuilder item: #'New TestRunner')
		parent: #System;
		order: 1;
		icon: UITheme current smallOkIcon;
		action: [NewTestRunner open]; 
		help: 'Opens a TestRunner to run your unit tests'! !

!NewTestRunner class methodsFor: 'opening' stamp: 'StephaneDucasse 2/22/2011 11:45'!
open
	"Open a SettingBrowser view"
	^ self new open! !

!NewTestRunner class methodsFor: 'updating' stamp: 'StephaneDucasse 2/22/2011 11:46'!
refreshAllTestRunners
	self allSubInstances do: [:sb | sb updateList]! !

!NewTestRunner class methodsFor: 'accessing' stamp: 'StephaneDucasse 2/22/2011 11:44'!
regexpSearch
	"Is the regexp filtering used"
	^ regexpSearch ifNil: [regexpSearch := false]! !

!NewTestRunner class methodsFor: 'accessing' stamp: 'StephaneDucasse 2/22/2011 11:44'!
regexpSearch: aBoolean
	"Set to true if the regexp filtering is to be used"

	regexpSearch := aBoolean! !

!NewTestRunner class methodsFor: 'accessing' stamp: 'StephaneDucasse 2/22/2011 11:44'!
searchedTextList
	"Keep a list of previously entered filtering tokens"
	^ searchedTextList ifNil: [searchedTextList := OrderedCollection new]! !

!NewTestRunner class methodsFor: 'world menu' stamp: 'StephaneDucasse 2/22/2011 14:40'!
taskbarIcon 

	^ UITheme current smallOkIcon! !

!NewTestRunner methodsFor: 'accessing' stamp: 'StephaneDucasse 3/14/2011 21:35'!
addToSearchedTextList: aString
	"Add the parameter to the list of searched strings."
	
	(self searchedTextList includes: aString) 
		ifFalse: [self searchedTextList size > 5
					ifTrue: [self searchedTextList removeFirst].
				self searchedTextList add: aString]! !

!NewTestRunner methodsFor: 'accessing' stamp: 'sd 3/18/2011 13:02'!
applyFilters

	self searchedText
		ifNotEmpty: [self updateAccordingTo: self textFilter].
	"self viewedPackages
		ifNotEmpty: [ | filter |
			self updateAccordingTo: filter]."
	self updateList
! !

!NewTestRunner methodsFor: 'processing' stamp: 'StephaneDucasse 3/14/2011 18:12'!
basicRunSuite: aTestSuite do: aBlock

	self basicSetUpSuite: aTestSuite.
	[ aTestSuite name isEmptyOrNil
		ifTrue: [ aTestSuite tests do: aBlock ]
		ifFalse: [ aTestSuite tests do: aBlock displayingProgress: aTestSuite name ] ]
			ensure: [ self basicTearDownSuite: aTestSuite ].
	! !

!NewTestRunner methodsFor: 'processing' stamp: 'StephaneDucasse 3/14/2011 18:12'!
basicSetUpSuite: aTestSuite

	aTestSuite resources do: [ :each |
		each isAvailable
			ifFalse: [ each signalInitializationError ] ].! !

!NewTestRunner methodsFor: 'processing' stamp: 'StephaneDucasse 3/14/2011 18:12'!
basicTearDownSuite: aTestSuite

	aTestSuite resources do: [ :each | each reset ].! !

!NewTestRunner methodsFor: 'user interface' stamp: 'StephaneDucasse 3/16/2011 21:59'!
buildSelectedClassList

	classList := PluggableListMorph
				on: self
				list: #getList
				selected: #selected
				changeSelected: #selected:
				menu: #menu2:shifted:.
	classList hResizing: #spaceFill.
	classList vResizing: #spaceFill.
	^ classList! !

!NewTestRunner methodsFor: 'user interface' stamp: 'StephaneDucasse 3/16/2011 21:56'!
buildWindowIn: aWindow 
	
	|  toolBarY gap localGap buttonsToolBar |
	packageDisplayer := self packageTreeMorph.
	toolBar := self toolBarIn: aWindow.
	buttonsToolBar := self buttonsToolBarIn: aWindow.
	gap := 5.
	toolBarY := toolBar minExtent y + gap.
	aWindow 
		addMorph: toolBar
		fullFrame: (LayoutFrame 
						fractions: (0 @ 0 corner: 1 @ 0)
						offsets: (0 @ (gap ) corner: 0 @ (toolBarY + gap))).
		
	aWindow 
		addMorph: packageDisplayer
		fullFrame: (LayoutFrame 
					fractions: (0 @ 0 corner: 0.30 @ 1)
					offsets: (0 @ toolBarY + gap corner: 0 @ toolBarY negated)).	
						
	aWindow
		addMorph: self buildSelectedClassList					
		fullFrame: (LayoutFrame 
					fractions: (0.30 @ 0 corner: 0.60 @ 1)
					offsets: (0 @ toolBarY + gap corner: 0 @ toolBarY negated)).					
	aWindow 
		addMorph:  buttonsToolBar
		fullFrame: (LayoutFrame 
					fractions: (0@1 corner: 1@1)
					offsets: (0@toolBarY negated corner: 0@0)).
	^ aWindow ! !

!NewTestRunner methodsFor: 'user interface' stamp: 'StephaneDucasse 3/14/2011 21:16'!
buttonsToolBarIn: aMorph 
	| toolBar |
	toolBar := aMorph newToolbar: {
		aMorph
			newButtonFor: self
			getState: nil
			action: #expandAll
			arguments: nil
			getEnabled: nil
			label: 'Expand all' translated
			help: 'Expand all tree nodes' translated.
		aMorph newToolSpacer.
		aMorph
				newCheckboxFor: self
				getSelected: #regexpSearch
				setSelected: #regexpSearch:
				getEnabled: nil
				label: 'Selectors' 
				help: 'Match selectors' translated.
		(EditableDropListMorph
					on: self
					list: #searchedTextList
					selected: #searchedText
					changeSelected: #changeSearchedText:
					useIndex: false 
					addToList: #addToSearchedTextList:
					class: String
					getEnabled: nil) hResizing: #spaceFill; 
				ghostText: 'Hit return to accept' translated.
		aMorph
				newCheckboxFor: self
				getSelected: #regexpSearch
				setSelected: #regexpSearch:
				getEnabled: nil
				label: 'Regexp' 
				help: 'Filter according to a regular expression' translated.
		aMorph newToolSpacer}.
	^ toolBar! !

!NewTestRunner methodsFor: 'processing' stamp: 'StephaneDucasse 3/14/2011 21:19'!
changeSearchedText: aString
 
	self searchedText ~= aString
		ifTrue: [self searchedText: aString.
			self applyFilters].
	^ true ! !

!NewTestRunner methodsFor: 'processing' stamp: 'StephaneDucasse 3/14/2011 18:13'!
debugSuite: aTestSuite
	self basicRunSuite: aTestSuite do: [ :each | each debug ].! !

!NewTestRunner methodsFor: 'user interface' stamp: 'StephaneDucasse 2/24/2011 09:20'!
errorList

	^ errorList :=  
		(MorphTreeMorph on: self) 
				multiSelection: true;
				autoDeselection: true;
				autoMultiSelection: true;
				itemSortBlock: [:a :b | a printString < b printString];
				itemStringGetter: [:item | item printString];
				hResizing: #spaceFill;
				vResizing: #spaceFill! !

!NewTestRunner methodsFor: 'user interface' stamp: 'StephaneDucasse 2/22/2011 12:11'!
expandAll
	self changed: #(#roots #expandAll).
! !

!NewTestRunner methodsFor: 'user interface' stamp: 'StephaneDucasse 3/16/2011 21:57'!
getList
	
	^ selectedClasses! !

!NewTestRunner methodsFor: 'testing' stamp: 'StephaneDucasse 3/14/2011 20:27'!
hasErrors
	^ result hasErrors.! !

!NewTestRunner methodsFor: 'testing' stamp: 'StephaneDucasse 3/14/2011 20:27'!
hasFailures
	^ result hasFailures.! !

!NewTestRunner methodsFor: 'testing' stamp: 'StephaneDucasse 3/14/2011 20:27'!
hasFailuresOrErrors
	^ result hasFailures | result hasErrors.! !

!NewTestRunner methodsFor: 'testing' stamp: 'StephaneDucasse 3/16/2011 21:38'!
hasRunnable
	^ selectedClasses notEmpty.! !

!NewTestRunner methodsFor: 'initialize' stamp: 'StephaneDucasse 3/16/2011 21:58'!
initialize

	super initialize.
	selectedClasses := OrderedCollection new.! !

!NewTestRunner methodsFor: 'utilities' stamp: 'StephaneDucasse 3/14/2011 20:34'!
label: aString forSuite: aTestSuite

	^ String streamContents: [ :stream |
		stream nextPutAll: 'Running '; print: aTestSuite tests size; space; nextPutAll: aString.
		aTestSuite tests size > 1 ifTrue: [ stream nextPut: $s ] ]. ! !

!NewTestRunner methodsFor: 'user interface' stamp: 'StephaneDucasse 2/22/2011 10:55'!
open
	"self new open"
	
	| window |
	window := StandardWindow new model: self.
	window title: 'New Test Runner'.
	self buildWindowIn: window.
	window themeChanged.
	window openInWorld.
	^ window! !

!NewTestRunner methodsFor: 'user interface' stamp: 'sd 3/18/2011 12:45'!
packageTreeMorph

	^ ((MorphTreeMorph on: (TRPackageDisplayer on: self))
				multiSelection: true;
				autoDeselection: true;
				autoMultiSelection: true;
				doubleClickSelector: #doubleClick;
				rowInset: 4;
				columnInset: 4;
				sortingSelector: #asString;
				getMenuSelector: #menu:shifted:;
				rowColorForEven: Color lightGray muchLighter odd: Color white) buildContents! !

!NewTestRunner methodsFor: 'accessing' stamp: 'StephaneDucasse 2/22/2011 12:03'!
regexpSearch
	^ self class regexpSearch! !

!NewTestRunner methodsFor: 'accessing' stamp: 'StephaneDucasse 3/14/2011 21:30'!
regexpSearch: aBoolean
	
	self class regexpSearch: aBoolean.
	self applyFilters
	"we could optimized and apply filters only if the text is not empty
	and some of the items changed"
! !

!NewTestRunner methodsFor: 'processing' stamp: 'StephaneDucasse 3/14/2011 20:26'!
reset
	self result: self testResultClass new; updateResults.! !

!NewTestRunner methodsFor: 'processing' stamp: 'sd 3/18/2011 12:59'!
rootItems

	^ (TestCase subclasses
		groupedBy: [:each | (PackageOrganizer default mostSpecificPackageOfClass: each)]) keys
		
	 ! !

!NewTestRunner methodsFor: 'processing' stamp: 'StephaneDucasse 3/14/2011 20:26'!
runAll
	self reset; runSuite: self suiteAll.
! !

!NewTestRunner methodsFor: 'processing' stamp: 'StephaneDucasse 3/14/2011 18:13'!
runSuite: aTestSuite
	self basicRunSuite: aTestSuite do: [ :each | self runTest: each ].
	self updateResults

! !

!NewTestRunner methodsFor: 'accessing' stamp: 'StephaneDucasse 2/22/2011 11:59'!
searchedText
	^ searchedText ifNil: [searchedText := '']! !

!NewTestRunner methodsFor: 'accessing' stamp: 'StephaneDucasse 2/22/2011 12:00'!
searchedText: aString
	searchedText := aString! !

!NewTestRunner methodsFor: 'accessing' stamp: 'StephaneDucasse 2/22/2011 12:00'!
searchedTextList
	^ self class searchedTextList! !

!NewTestRunner methodsFor: 'accessing tests' stamp: 'StephaneDucasse 3/16/2011 21:38'!
selectAllUnitTests
	
	selectedClasses := classes asSet select: [ :eachClass | eachClass isUnitTest ].! !

!NewTestRunner methodsFor: 'initialize' stamp: 'StephaneDucasse 3/16/2011 21:58'!
selected

	^ 0! !

!NewTestRunner methodsFor: 'accessing' stamp: 'sd 3/18/2011 12:57'!
selectedClasses: aCol

	selectedClasses := aCol.
	self changed: #getList! !

!NewTestRunner methodsFor: 'accessing tests' stamp: 'StephaneDucasse 3/16/2011 21:38'!
suiteAll
	^ self testSuiteClass new in: [ :suite |
		selectedClasses do: [ :each | 
			each isAbstract 
				ifFalse: [ each addToSuiteFromSelectors: suite ] ].
		suite name: (self label: 'Test' forSuite: suite) ].! !

!NewTestRunner methodsFor: 'accessing tests' stamp: 'StephaneDucasse 3/14/2011 20:25'!
suiteErrors
	^ self testSuiteClass new in: [ :suite |
		suite 
			addTests: errorList; 
			name: (self label: 'Error' forSuite: suite) ].! !

!NewTestRunner methodsFor: 'accessing tests' stamp: 'StephaneDucasse 3/14/2011 20:25'!
suiteFailures
	^ self testSuiteClass new in: [ :suite |
		suite 
			addTests: failedList; 
			name: (self label: 'Failure' forSuite: suite) ].! !

!NewTestRunner methodsFor: 'accessing' stamp: 'sd 3/18/2011 13:02'!
testPackages

	^ ((TestCase subclasses copyFrom: 1 to: 5)
		groupedBy: [:each | (PackageOrganizer default mostSpecificPackageOfClass: each)]) keys
		
	 ! !

!NewTestRunner methodsFor: 'accessing tests' stamp: 'StephaneDucasse 3/14/2011 18:15'!
testResultClass
	^ TestResult! !

!NewTestRunner methodsFor: 'accessing tests' stamp: 'StephaneDucasse 3/14/2011 20:24'!
testSuiteClass
	^ TestSuite! !

!NewTestRunner methodsFor: 'user interface' stamp: 'StephaneDucasse 2/23/2011 18:48'!
textFilter
	^ self regexpSearch
		ifFalse: [TestTokenFilter new token: self searchedText]
		ifTrue: [TestRegexFilter new regexp: self searchedText] ! !

!NewTestRunner methodsFor: 'user interface' stamp: 'StephaneDucasse 3/14/2011 21:17'!
toolBarIn: aMorph 
	| toolBar |
	toolBar := aMorph newToolbar: {
		aMorph
			newButtonFor: self
			getState: nil
			action: #expandAll
			arguments: nil
			getEnabled: nil
			label: 'Expand all' translated
			help: 'Expand all tree nodes' translated.
		aMorph newToolSpacer.
		aMorph
				newCheckboxFor: self
				getSelected: #regexpSearch
				setSelected: #regexpSearch:
				getEnabled: nil
				label: 'Selectors' 
				help: 'Match selectors' translated.
		(EditableDropListMorph
					on: self
					list: #searchedTextList
					selected: #searchedText
					changeSelected: #changeSearchedText:
					useIndex: false 
					addToList: #addToSearchedTextList:
					class: String
					getEnabled: nil) hResizing: #spaceFill; 
				ghostText: 'Hit return to accept' translated.
		aMorph
				newCheckboxFor: self
				getSelected: #regexpSearch
				setSelected: #regexpSearch:
				getEnabled: nil
				label: 'Regexp' 
				help: 'Filter according to a regular expression' translated.
		aMorph newToolSpacer}.
	^ toolBar! !

!NewTestRunner methodsFor: 'user interface' stamp: 'sd 3/18/2011 12:57'!
updateAccordingTo: aFilter

	packageDisplayer model selection: nil.
	self updateList. 	"To avoid composing requests"
	[ packageDisplayer model  rootNodes do: [:r | r updateAccordingTo: aFilter].
	packageDisplayer model  rootNodes removeAllSuchThat: [:n | (aFilter keepNode: n) not and: [n isEmpty]]]
		on: RegexSyntaxError
		do: [:ex | 
			self setDescription: 'Regular expression syntax error, see `documentation'' protocol of RxParser class for user''s guide'].
	self expandAll! !

!NewTestRunner methodsFor: 'user interface' stamp: 'StephaneDucasse 2/23/2011 18:36'!
updateList
	self changed: #rootNodes.
! !

Object subclass: #TestNodeSelectionFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewTestRunner'!

!TestNodeSelectionFilter commentStamp: 'alain.plantec 4/8/2009 12:51' prior: 0!
A TestNodeSelectionFilter is a filter wich is used by a SettingBrowser in order to select which nodes of the setting trees are to be shown. A TestNodeSelectionFilter subclass must redefine the #keepHandler: method which return true if the argument handler is to be kept.

Instance Variables
!

!TestNodeSelectionFilter methodsFor: 'filtering' stamp: 'alain.plantec 9/18/2009 23:46'!
keepSettingTreeNode: aTestNode 
	^ false! !

TestNodeSelectionFilter subclass: #TestPackageFilter
	instanceVariableNames: 'packages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewTestRunner'!

!TestPackageFilter commentStamp: 'AlainPlantec 12/31/2010 11:38' prior: 0!
A TestPackageFilter is a TestNodeSelectionFilter used to select settings from a given list of packages: a setting is kept only if the package in which it is defined is present in the given package list

Instance Variables
	packages:		<Collection>

packages
	- The collection of PackageInfo the filter is currently using!

!TestPackageFilter methodsFor: 'filtering' stamp: 'StephaneDucasse 2/23/2011 18:08'!
keepNode: aTestNode 

	^ aTestNode keepForPackage: packages! !

!TestPackageFilter methodsFor: 'accessing' stamp: 'alain.plantec 3/16/2009 23:00'!
packages
	"Answer the value of packages"

	^ packages! !

!TestPackageFilter methodsFor: 'accessing' stamp: 'alain.plantec 4/8/2009 12:55'!
packages: aCollectionOfPackageInfo
	"Set the value of packages"

	packages := aCollectionOfPackageInfo
! !

TestNodeSelectionFilter subclass: #TestRegexFilter
	instanceVariableNames: 'regexp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewTestRunner'!

!TestRegexFilter commentStamp: 'alain.plantec 4/8/2009 13:02' prior: 0!
A TestRegexFilter is TestNodeSelectionFilter which makes use of a regular expression in order to keep or not a SettingHandler.

Instance Variables
	regexp:		<String>

regexp
	- a regular expression string
!

!TestRegexFilter methodsFor: 'filtering' stamp: 'StephaneDucasse 2/23/2011 18:07'!
keepNode: aTestNode 
	
	^ aTestNode keepForRegex: regexp! !

!TestRegexFilter methodsFor: 'accessing' stamp: 'alain.plantec 4/7/2009 23:52'!
regexp
	"Answer the value of regexp"

	^ regexp! !

!TestRegexFilter methodsFor: 'accessing' stamp: 'alain.plantec 4/7/2009 23:52'!
regexp: anObject
	"Set the value of regexp"

	regexp := anObject! !

TestNodeSelectionFilter subclass: #TestTokenFilter
	instanceVariableNames: 'token'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewTestRunner'!

!TestTokenFilter commentStamp: 'alain.plantec 4/8/2009 13:03' prior: 0!
A TestTokenFilter is TestNodeSelectionFilter which makes use of a token (substring) in order to keep or not a SettingHandler.


Instance Variables
	token:		<String>

!

!TestTokenFilter methodsFor: 'filtering' stamp: 'StephaneDucasse 2/23/2011 18:08'!
keepNode: aTestNode 

	^ aTestNode keepForToken: token

	! !

!TestTokenFilter methodsFor: 'accessing' stamp: 'alain.plantec 3/16/2009 22:51'!
token
	"Answer the value of token"

	^ token! !

!TestTokenFilter methodsFor: 'accessing' stamp: 'alain.plantec 3/16/2009 22:51'!
token: aString
	"Set the value of token"

	token := aString! !
